#pragma rtGlobals=1		// Use modern global access method.
#pragma version=1.00-dev	//July, 2008

//Tab control procedures written by B. Cramer

strconstant ksJunkFolder="root:Packages:DynamiTabs"

Function MakeTabDynamic(windowName,tabCtrlName[,PreferredProcedureName])
	string windowName,tabCtrlName,PreferredProcedureName
	
	if(!DynamiTab_Exists(windowName,tabCtrlName))
		return 0
	endif
	
	if(paramisDefault(PreferredProcedureName))
		PreferredProcedureName=""
	endif
	TabControl $tabCtrlName,proc=DynamiTabAction,win=$windowName		//attach action procedure
	TabControl $tabCtrlName,userdata(DT_PrefProc)=StringByKey("PROCWIN",FunctionInfo(GetRTStackInfo(2))),win=$windowName	//store primary procedure window
	TabControl $tabCtrlName,userdata(DT_TabList)="",win=$windowName			//store initially blank tab list
//Fill the Igor TabControl action structure:
	struct WMTabControlAction TCs
	TCs.win=windowName
	TCs.ctrlName=tabCtrlName
	TCs.tab=0			//when first drawn, the 0th tab will be selected
	TCs.eventcode=2
	DynamiTabAction(TCs)
end

Function DynamiTabAction(TCs)
	struct WMTabControlAction &TCs

	variable nitems,i

	string prefix=TCs.ctrlName+"AddTab_"
	if(TCs.eventcode==2)
//gathers available tab functions, finds selected tab in new tab list
		string oldTabList=GetUserData(TCs.win,TCs.ctrlName,"DT_TabList")						//Get names of previously drawn tabs
		string PreferredProcedureName=GetUserData(TCs.win,TCs.ctrlName,"DT_PrefProc")		//Get name of procedure file to search first
		if(strlen(PreferredProcedureName))	//if there is one....
			string TabList=FunctionList(prefix+"*",";","NPARAMS:1,VALTYPE:1,KIND:6,WIN:"+PreferredProcedureName)	//load from preferred procedure file first
		else
			TabList=""
		endif
		TabList+=removefromlist(TabList,FunctionList(prefix+"*",";","NPARAMS:1,VALTYPE:1,KIND:18"))		//load from other procedure files
		TabList=ReplaceString(prefix,removefromlist("AddDynamicTab_prototype",TabList),"")			//removes prototype function and strips prefix

		string selectedTab=stringfromlist(TCs.tab,oldTabList)		//Get current tab name
		TCs.tab=max(0,whichListItem(selectedTab,TabList))		//Get number of current tab in new tab list - default to 0 if current tab name is absent
		selectedTab=stringfromlist(TCs.tab,TabList)				//repeat - in case selected tab is no longer available this will give 0th tab name

//kill current controls	--		does not allow for non-tabbed controls
		string TabbedControlNames=removefromlist(TCs.ctrlName,ControlNameList(TCs.Win))
		nItems=itemsinlist(TabbedControlNames)
		for(i=0;i<nItems;i+=1)
			killControl/w=$TCs.win $stringfromlist(i,TabbedControlNames)
		endfor
		
//Tabs
		nitems=itemsinlist(oldTabList)
		for(i=0;i<nitems;i+=1)		//remove all tabs
			TabControl $TCs.ctrlName,tablabel(i)="",win=$TCs.Win
		endfor
		nitems=itemsinlist(TabList)
		for(i=0;i<nitems;i+=1)		//create new tabs
			TabControl $TCs.ctrlName,tablabel(i)=stringfromlist(i,TabList),win=$TCs.Win
		endfor
		TabControl $TCs.ctrlName,proc=DynamiTabAction,win=$TCs.Win	//redraw tab control
		TabControl $TCs.ctrlName userdata(DT_TabList)=TabList,userdata(DT_PrefProc)=PreferredProcedureName,value=TCs.tab,disable=0,win=$TCs.Win

//build controls for current tab
		TabbedControlNames=ControlNameList(TCs.Win)	//get list of non-tabbed controls
		FuncRef AddDynamicTab_prototype TabFunc=$(prefix+selectedTab)
		TabFunc(TCs.win)		//call procedure to create controls for this tab
		TabbedControlNames=removefromlist(TabbedControlNames,ControlNameList(TCs.Win))	//list of tabbed controls is all controls with non-tabbed controls removed
		TabControl $TCs.ctrlName,userdata(DT_CtrlList)=TabbedControlNames,win=$TCs.win
		nItems=itemsinlist(TabbedControlNames)
		for(i=0;i<nItems;i+=1)
//detour action procedure for each control
			string thisCtrl=stringfromlist(i,TabbedControlNames)
			string OriginalActionProcedure=ControlRecreationParse(TCs.Win,thisCtrl,"proc")
			ModifyControl/Z $thisCtrl userData(actionProcedure)=OriginalActionProcedure,win=$TCs.win
			ModifyControl/Z $thisCtrl proc=$("DynamiTab"+ControlType(TCs.Win,thisCtrl)+"Proc"),win=$TCs.win
		endfor
	endif
End

Function RedrawDynamicTab(windowName,tabCtrlName)
	string windowName,tabCtrlName
	
	if(!DynamiTab_Exists(windowName,tabCtrlName))
		return 0
	endif
	
//Fill the Igor TabControl action structure:
	struct WMTabControlAction TCs
	TCs.win=windowName
	TCs.ctrlName=tabCtrlName
	controlInfo/W=$TCs.win $tabCtrlName
	TCs.tab=v_value			//set to current tab
	TCs.eventcode=2
	DynamiTabAction(TCs)
end

Function AddDynamicTab_prototype(windowName)
	string windowName
	
end

Function DynamiTab_Exists(windowName,tabCtrlName)
	string windowName,tabCtrlName

	ControlInfo/w=$windowName $tabCtrlName
	return v_flag==8
end	

Function/t ControlRecreationParse(windowName,ctrlName,keyword)	//picks out the value of control creation commands
	string windowName,ctrlName,keyword
	
	controlInfo/w=$windowName $ctrlName
	return stringfromlist(0,StringByKey(keyword,S_Recreation,"=",",",1),"\r")
end

Function/t ControlType(windowName,ctrlName)
	string windowName,ctrlName
	
	ControlInfo/W=$windowName $ctrlName
	switch(V_flag)
		case 0:
			return ""
		case 1:				//Button
			return "Button"
		case 2:				//CheckBox
			return "CheckBox"
		case 3:				//PopupMenu
		case -3:			//inactive PopupMenu
			return "Popup"
		case 4:				//ValDisplay
		case -4:			//inactive ValDisplay
			return "ValDisplay"
		case 5:				//SetVariable
		case -5:			//inactive SetVariable
			return "SetVariable"
		case 6:				//Chart
		case -6:			//inactive Chart
			return "Chart"
		case 7:				//Slider
			return "Slider"
		case 8:				//TabControl
			return "TabControl"
		case 9:				//GroupBox
			return "GroupBox"
		case 10:			//TitleBox
			return "TitleBox"
		case 11:			//ListBox
			return "ListBox"
		case 12:			//CustomControl
			return "CustomControl"
		default:
			return "Unrecognized"
	endSwitch
end

Function/t PopupValueList(windowName,ctrlName)
	string windowName,ctrlName
	
	ControlInfo/W=$windowName $ctrlName
	if(abs(v_flag)!=3)		//make sure this is a popup control
		return ""
	endif
	NewDataFolderPath(ksJunkFolder)
	string/g $(ksJunkFolder+":PopupValueStr")					//global string to use for Execute
	SVAR PopupValueStr=$(ksJunkFolder+":PopupValueStr")
	string executeStr=controlRecreationParse(windowName,ctrlName,"value")								//parse recreation commands
	executeStr=executeStr[strsearch(executeStr,"\"",0)+1,strsearch(executeStr,"\"",strlen(executeStr)-1,1)-1]	//strip enclosing quotes
	executeStr=ReplaceString("\\\"",executeStr,"\"")				//change to non-escaped quotes
	executeStr=ksJunkFolder+":PopupValueStr="+executeStr
	Execute/q/z executeStr											//Executes popup value code from command line, placing result in global string
	string returnStr=PopupValueStr									//get value of global string
	killDataFolder $ksJunkFolder									//cleanup
	return returnStr
end

Function DynamiTabButtonProc(WMs)
	struct WMButtonAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabButtonProc ButtonActionProcedure=$OriginalActionProcedure
		ButtonActionProcedure(WMs)
	endif
end

Function DynamiTabCheckBoxProc(WMs)
	struct WMCheckBoxAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	switch(WMs.eventCode)
		case 2:		//mouse up
			string userdataStr=getUserData(WMs.win,WMs.ctrlName,"DT_CheckBoxData")
			userdataStr=replaceNumberByKey(WMs.ctrlName,userdataStr,WMs.checked,":",";")
			CheckBox $WMs.ctrlName,userdata(DT_CheckBoxData)=userdataStr,win=$WMs.win
			break
	endSwitch
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabCheckBoxProc CheckBoxActionProcedure=$OriginalActionProcedure
		CheckBoxActionProcedure(WMs)
	endif
end

Function DynamiTabPopupProc(WMs)
	struct WMPopupAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabPopupProc PopupActionProcedure=$OriginalActionProcedure
		PopupActionProcedure(WMs)
	endif
end

Function DynamiTabSetVariableProc(WMs)
	struct WMSetVariableAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabSetVariableProc SetVariableActionProcedure=$OriginalActionProcedure
		SetVariableActionProcedure(WMs)
	endif
end

Function DynamiTabSliderProc(WMs)
	struct WMSliderAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabSliderProc SliderActionProcedure=$OriginalActionProcedure
		SliderActionProcedure(WMs)
	endif
end

Function DynamiTabTabControlProc(WMs)
	struct WMTabControlAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabTabControlProc TabControlActionProcedure=$OriginalActionProcedure
		TabControlActionProcedure(WMs)
	endif
end

Function DynamiTabListBoxProc(WMs)
	struct WMListBoxAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabListBoxProc ListBoxActionProcedure=$OriginalActionProcedure
		ListBoxActionProcedure(WMs)
	endif
end

Function DynamiTabCustomControlProc(WMs)
	struct WMCustomControlAction &WMs
	
	if(itemsinlist(GetRTStackInfo(3))>1)		//This avoids overlapping calls, but may be undesirable in some circumstances
		return -1
	endif
	
	string OriginalActionProcedure=GetUserData(WMs.win,WMs.ctrlName,"actionProcedure")
	if(strlen(OriginalActionProcedure))			//test if original action procedure was specified
		funcRef DynamiTabCustomControlProc CustomControlActionProcedure=$OriginalActionProcedure
		CustomControlActionProcedure(WMs)
	endif
end

static Function NewDataFolderPath(path[,set,overwrite])
	string path
	variable set,overwrite
	
	variable depth=itemsinlist(path,":"),i
	if(overwrite)
		killDataFolder/Z $path
	endif
	string partial="root"
	for(i=1;i<depth;i+=1)
		partial+=":"+possiblyquotename(StringFromList(i,path,":"))
		newdatafolder/o $partial
	endfor
	if(set)
		SetDataFolder $partial
	endif
end
